package jp.gr.java_conf.matsubara.expresser.operatorset;

import jp.gr.java_conf.matsubara.expresser.*;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.*;

/**
 * _l^ɑ΂鉉ZqZbgłB<br/>
 * <br/>
 * 쐬: 2004/12/26
 * 
 * @author m.matsubara
 *
 */
public class BooleanOperatorSet implements IOperatorSet {
    public static final BooleanOperatorSet operatorSet = new BooleanOperatorSet();
    public Class[] targetType() {
        Class[] result = { _Boolean.class };
        
        return result;
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.operatorset.IOperatorSet#operation(int, java.lang.Object, java.lang.Object, jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject operation(int operator, IExpObject operand1, IExpObject operand2, RuntimeData runtime) throws ExpException {
        switch (operator) {
        case OperatorData.OP_CMP_EQ_STRICT:
        	try {
        		return new _Boolean(operand1.equals(operand2));
        	} catch (ClassCastException e) {
        		//  f[^^Ȃ
        		return new _Boolean(false);
        	}
        case OperatorData.OP_CMP_NE_STRICT:
        	try {
        		return new _Boolean(! operand1.equals(operand2));
        	} catch (ClassCastException e) {
        		//  f[^^Ȃ
        		return new _Boolean(false);
        	}
        default:	
	    	if (!(operand2 instanceof _Boolean)) {
                operand2 = runtime.getTypeConverter().toPrimitive(runtime, operand2);
	            if (operand2 instanceof _String) {
	                return StringOperatorSet.operatorSet.operation(operator, operand1, operand2, runtime);
                } else if (operand2 instanceof ExpNumberBase) {
	                operand1 = runtime.getTypeConverter().toNumber(runtime, operand1);
	                return DoubleOperatorSet.operatorSet.operation(operator, operand1, operand2, runtime);
	            } else {
                    return _DefaultOperatorSet.operatorSet.operation(operator, operand1, operand2, runtime);
                }
	        }
	        
	        switch (operator) {
	        case OperatorData.OP_CMP_EQ:
	            return new _Boolean(((_Boolean)operand1).booleanValue() == ((_Boolean)operand2).booleanValue()); 
	        case OperatorData.OP_CMP_NE:
	            return new _Boolean(((_Boolean)operand1).booleanValue() != ((_Boolean)operand2).booleanValue()); 
	        case OperatorData.OP_LOG_NOT:
	            return new _Boolean(! ((_Boolean)operand2).booleanValue());
	        default:
	            return _DefaultOperatorSet.operatorSet.operation(operator, operand1, operand2, runtime);
	        }
        }
    }
}
