package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;

/**
 * \͍ς݂̌vZłB<br/>
 * <br/>
 * 쐬: 2005/02/05
 * 
 * @author m.matsubara
 */
public class Op_LogicalAndExpression implements IParsedExpression {
    private IParsedExpression operand1Expression;
    private IParsedExpression operand2Expression;
    private int operatorIdx;

    public Op_LogicalAndExpression(IParsedExpression operand1, IParsedExpression operand2, int operatorIdx) throws ExpException {
        this.operand1Expression = operand1;
        this.operand2Expression = operand2;
        this.operatorIdx = operatorIdx;
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IparsedExpression#isUsingVariable(Integer id)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        result += ((IParsedExpression)operand1Expression).isUsingVariable(id);
        result += ((IParsedExpression)operand2Expression).isUsingVariable(id);
        return result;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.Op_LogicalAndExpression.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException {
        IExpObject operand1 = ((IParsedExpression)this.operand1Expression).evaluate(runtime);
        IExpObject operand2 = ((IParsedExpression)this.operand2Expression).evaluate(runtime);

        try {
            //  Iyh false ̂ƂAEIyh]Afalse ԂB
            ITypeConverter typeConverter = runtime.getTypeConverter();
            if (typeConverter.toBoolean(runtime, operand1).booleanValue() == false)
                return new _Boolean(false);
            if (typeConverter.toBoolean(runtime, operand2).booleanValue() == false)
                return new _Boolean(false);
            return new _Boolean(true);
        } catch (ExpException ee) {
            //  position ێȂO⑫ApositionĐݒ肵ăX[
            if (ee.getPosition() < 0)
                ee.setPosition(this.operatorIdx);
               throw ee;        //  Lb`OʒuێĂȂꍇAZqʒuG[ʒuƂčăX[
        }
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), -1);
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    public boolean isConst() {
        return ((operand1Expression instanceof IParsedExpression) == false) && ((operand2Expression instanceof IParsedExpression) == false);
    }
    
    public Object getOperand1() {
        return operand1Expression;
    }

    public Object getOperand2() {
        return operand2Expression;
    }
}
