package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * bvꂽϐIuWFNgłB<br/>
 * <br/>
 * 쐬: 2005/02/05
 * 
 * @author m.matsubara
 */
public class WrappedVariableExpression implements IParsedExpression {
    private String variableName;    //  TODO gȂHifobO@\gj
    private Integer variableId;
    
    private int offset = 0;    //  ϐւ̃CfbNXiRuntimeDataŕϐւ̃ANZXɎgijj
    
    private int position;
    
    public WrappedVariableExpression(String variableName, Integer variableId, int position) {
        this.variableName = variableName;
        this.variableId = variableId;
        this.position = position;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        if (variableId.intValue() == id.intValue()) {
            return 1;
        } else {
            return 0;
        }
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evaluate(RuntimeData runtime) throws ExpException {
        try {
            if (offset != 0) {
                if (offset > 0)
                    return runtime.getValue(variableId, offset);
                else
                    return runtime.getValue(variableId);  //  offsetȂŕϐ擾B
            }
            else {
                offset = runtime.getVariableOffset(variableId);
                if (offset != 0)
                    return runtime.getValue(variableId, offset);
                else {
                    offset = -1;
                    IVariable variable = runtime.getVariable(variableId, false);  //  offsetȂŕϐ擾BϐȂꍇ̓G[
                    if (variable != null)
                        return variable.getValue();
                    else
                        throw new ExpException(Expresser.getResString("UndefinedVariable"), position);
                }
            }
        } catch (ExpException ee) {
            if (ee.getPosition() < 0)
                ee.setPosition(position);
            throw ee;
        }
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalRef(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IVariable evalRef(RuntimeData runtime) throws ExpException {
        try {
            if (offset != 0) {
                if (offset > 0)
                    return runtime.getVariable(variableId, offset);
                else
                    return runtime.getVariable(variableId, false);  //  offsetȂŕϐ擾B
            }
            else {
                offset = runtime.getVariableOffset(variableId);
                if (offset != 0)
                    return runtime.getVariable(variableId, offset);
                else {
                    offset = -1;
                    return runtime.getVariable(variableId, true);  //  offsetȂŕϐ擾BϐȂꍇ͍쐬
                }
            }
        } catch (ExpException ee) {
            if (ee.getPosition() < 0)
                ee.setPosition(position);
            throw ee;
        }
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression#evalTargetObject(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public IExpObject evalTargetObject(RuntimeData runtime) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isConst()
     */
    public boolean isConst() {
        return false;
    }
    
    /**
     * ϐ̎擾
     * @return ϐ
     */
    public String getVariableName() {
        return variableName;
    }
}
