package jp.gr.java_conf.matsubara.expresser.type;

import java.util.ArrayList;
import java.util.List;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.Variable;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;


/**
 * v~eBu^̘_l^łB<br/>
 * <br/>
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 *
 */
public class _Boolean implements IExpObject {
    private boolean value;

    private static ExpObject prototype = null;
    
    public _Boolean(boolean value) throws ExpException {
        this.value = value;
        getPrototype();
    }
    
    public boolean booleanValue() {
        return value;
    }
    
    public String toString() {
        return String.valueOf(value);
    }
    
    public boolean equals(Object object) {
        Class classObject = object.getClass();
        if (classObject == _Boolean.class) {
            return ((_Boolean)object).booleanValue() == value;
        } else if (classObject == Boolean.class) {
            return ((Boolean)object).booleanValue() == value;
        } else {
            return false;
        }
    }

    public int hashCode() {
        return value ? 1 : 0;
    }
    
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#deleteProperty(java.lang.Integer)
     */
    public IExpObject deleteProperty(Integer id) throws ExpException {
        return new _Boolean(true);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        IExpObject obj = prototype.getProperty(id);
        return obj;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(java.lang.Integer, java.lang.Object)
     */
    public void putProperty(Integer id, IExpObject value) throws ExpException {
        // Ȃ
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(int)
     */
    public IExpObject getProperty(int index) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(int, java.lang.Integer)
     */
    public void putProperty(int index, IExpObject value) throws ExpException {
        // Ȃ
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(java.lang.Integer)
     */
    public IVariable getVariable(Integer id) {
        return new ExpObjectMember(this, id);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(int)
     */
    public IVariable getVariable(int index) {
        return new Variable(Expresser.UNDEFINED);  //   ANZXĂG[ɂȂȂAl͏undefinedƂȂ  
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#isProperty(java.lang.Integer, boolean)
     */
    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        if (searchPrototype)
            return prototype.isProperty(id, searchPrototype);
        else
            return false;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getConstructorList()
     */
    public List getConstructorList() {
        return new ArrayList(0);
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#enumProperty()
     */
    public Integer[] enumProperty() {
        return new Integer[0];
    }

    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static synchronized ExpObject getPrototype() throws ExpException {
        if (prototype == null) {
            prototype = new ExpObject(ExpObject.getPrototype());
        }
        return prototype;
    }
}
