package jp.gr.java_conf.matsubara.expresser.type.constructor;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumber;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Double;

/**
 * Number^̃RXgN^łB<br/>
 * <br/>
 * 쐬: 2005/05/03
 * 
 * @author m.matsubara
 */

public class ExpNumber_constructor extends ExpFunctionBase {
    /**
     * Number^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public ExpNumber_constructor() throws ExpException {
        super("Number", 1);
        putProperty(StringToId.toId("prototype"), ExpNumber.getPrototype());
        putProperty(StringToId.toId("MIN_VALUE"),         new _Double(Double.MIN_VALUE));
        putProperty(StringToId.toId("MAX_VALUE"),         new _Double(Double.MAX_VALUE));
        putProperty(StringToId.toId("NaN"),               new _Double(Double.NaN));
        putProperty(StringToId.toId("NEGATIVE_INFINITY"), new _Double(Double.NEGATIVE_INFINITY));
        putProperty(StringToId.toId("POSITIVE_INFINITY"), new _Double(Double.POSITIVE_INFINITY));
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length >= 1) {
            if (thisObject != Expresser.UNDEFINED) {  //  RXgN^Ăяo̔
                if (arguments[0] instanceof ExpNumberBase)
                    return new ExpNumber(((ExpNumberBase)arguments[0]).doubleValue());
                else {
                    ITypeConverter typeConverter = runtime.getTypeConverter();
                    return new ExpNumber(typeConverter.toNumber(runtime, arguments[0]).doubleValue());
                }
            } else {
                ITypeConverter typeConverter = runtime.getTypeConverter();
                return typeConverter.toNumber(runtime, arguments[0]);
            }
        } else {
            return new ExpNumber(0);
        }
        
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id.intValue() == ExpObject_constructor.propertyId$prototype.intValue())
            return ExpNumber.getPrototype();
        return super.getProperty(id);
    }
}
