package jp.gr.java_conf.matsubara.expresser.type.constructor;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpRegExp;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * RegExp^̃RXgN^łB<br/>
 * <br/> 
 * 쐬: 2005/05/03
 * 
 * @author m.matsubara
 */

public class ExpRegExp_constructor extends ExpFunctionBase {
    /**
     * RegExp^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public ExpRegExp_constructor() throws ExpException {
        super("RegExp", 2);
        putProperty(StringToId.toId("prototype"), ExpRegExp.getPrototype());
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        ITypeConverter typeConverter = runtime.getTypeConverter();
        if (arguments.length >= 1) {
            if (arguments[0] instanceof ExpRegExp) {
                return (ExpRegExp)(arguments[0]);
            } else {
                String pattern = typeConverter.toString(runtime, arguments[0]).toString();
                String flags = "";
                if (arguments.length >= 2)
                    arguments[1].toString();
                return new ExpRegExp(pattern, flags);
            } 
        } else {
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        }
        
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id.intValue() == ExpObject_constructor.propertyId$prototype.intValue())
            return ExpRegExp.getPrototype();
        return super.getProperty(id);
    }
    
}
