package jp.gr.java_conf.matsubara.expresser.type.constructor;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpString;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * String^̃RXgN^łB<br/>
 * <br/> 
 * 쐬: 2005/05/01
 * 
 * @author m.matsubara
 */

public class ExpString_constructor extends ExpFunctionBase {
    /**
     * String^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public ExpString_constructor() throws ExpException {
        super("String", 1);
        putProperty(StringToId.toId("prototype"), ExpString.getPrototype());
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        ITypeConverter typeConverter = runtime.getTypeConverter();
        if (arguments.length >= 1) {
            if (thisObject != Expresser.UNDEFINED) {  //  RXgN^Ăяo̔
                String value = typeConverter.toString(runtime, arguments[0]).toString();
                return new ExpString(value);
            } else {
                return typeConverter.toString(runtime, arguments[0]); 
            }
        } else {
            return new ExpString(null);
        }
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id.intValue() == ExpObject_constructor.propertyId$prototype.intValue())
            return ExpString.getPrototype();
        return super.getProperty(id);
    }
}
