package jp.gr.java_conf.matsubara.expresser.type.property;

import java.io.UnsupportedEncodingException;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;


/**
 * Global^ encodeURI() \bhłB<br/>
 * <br/>
 * 쐬: 2005/07/30
 * 
 * @author m.matsubara
 */

public class Global__encodeURI extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("encodeURI");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__encodeURI() throws ExpException {
        super("encodeURI", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        
        String uri = runtime.getTypeConverter().toString(runtime, arguments[0]).toString();
        StringBuffer result = new StringBuffer(uri.length() * 12 / 10);
        int max = uri.length();
        for (int idx = 0; idx < max; idx++) {
            char ch = uri.charAt(idx);
            if (ch > 256 || ch == ' ' || ch == '"' || ch == '%' || ch == '^' ||  
                    ch == '\\' || ch == '|' || ch == '`' || ch == '[' ||  
                    ch == '{' || ch == '}' || ch == ']' || ch == '<' || ch == '>') {
                try {
                    byte[] bytes = (String.valueOf(ch)).getBytes("UTF-8");
                    for (int byteIdx = 0; byteIdx < bytes.length; byteIdx++) {
                        int hex = bytes[byteIdx];
                        result.append('%');
                        result.append(toHexString(hex));
                    }
                } catch (UnsupportedEncodingException uee) {
                    //  蓾Ȃ
                }
            } else {
                result.append(ch);
            }
        }
        return new _String(result.toString());
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__encodeURI();
        return instance;
    }
    
    /**
     * lQ͂ŜPUiɒu܂B
     * @param hex
     * @return
     */
    public static String toHexString(int hex) {
        StringBuffer result = new StringBuffer(2);
        char[] hexChar = new char[] {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
        int hi;
        int low;
        if (hex >= 256) {
            hi =  (hex >> 12) & 0x0f;
            low = (hex >>  8) & 0x0f;
            result.append(hexChar[hi]);
            result.append(hexChar[low]);
        }
        hi = (hex >> 4) & 0x0f;
        low = hex & 0x0f;
        result.append(hexChar[hi]);
        result.append(hexChar[low]);
        return result.toString();
    }
}
