package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._Double;

/**
 * Global^ parseInt() \bhłB<br/>
 * ̃\bhECMA262Kiɂ͂܂<br/>
 * <br/>
 * 쐬: 2005/07/24
 * 
 * @author m.matsubara
 */

public class Global__parseInt extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("parseInt");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__parseInt() throws ExpException {
        super("parseInt", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        
        ITypeConverter typeConverter = runtime.getTypeConverter(); 
        //  𔻒
        int radix = -1;
        if (arguments.length >= 2) {
            radix = typeConverter.toNumber(runtime, arguments[1]).intValue();
            if (radix < 0 || radix > 36) {
                return new _Double(Double.NaN);
            }
        }
        String string = typeConverter.toString(runtime, arguments[0]).toString().trim();
        //  
        boolean minusFlag = false;
        if (string.charAt(0) == '-') {
            minusFlag = true;
            string = string.substring(1);
        }
        if (string.length() == 0)
            return new _Double(Double.NaN);

        //  𔻒
        if (string.charAt(0) == '0') {
            if (string.length() == 1)
                return new _Double(0);
            if (string.length() >= 2 && (string.charAt(1) == 'x' || string.charAt(1) == 'X')) {
                if (radix != -1 && radix != 16)
                    return new _Double(0);  //  NaNł͂Ȃ́H (rhinoɂ킹Ă)
                radix = 16;
                if (string.length() == 2)
                    return new _Double(Double.NaN);
                string = string.substring(2);
            } else { 
                radix = 8;
            }
        }
        if (radix == -1) {
            radix = 10;
        }
        
        //  ̃fR[h
        int result = 0;
        int max = string.length();
        if (max == 0)
            return new _Double(Double.NaN);
        for (int idx = 0; idx < max; idx++) {
            int val;
            char ch = string.charAt(idx);
            if (ch >= '0' && ch <= '9')
                val = (ch - '0');
            else if (ch >= 'a' && ch <= 'z')
                val = (10 + (ch - 'a'));
            else if (ch >= 'A' && ch <= 'Z')
                val = (10 + (ch - 'A'));
            else
                break;
            if (val >= radix)
                return new _Double(Double.NaN);
            result *= radix;
            result += val;
        }
        
        if (minusFlag)
            return new _Double(result * -1);
        else
            return new _Double(result);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__parseInt();
        return instance;
    }
}
