package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;

/**
 * Object^ hasOwnProperty() \bhłB<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */
public class Object__hasOwnProperty extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("hasOwnProperty");
    private static IExpObject instance = null;  

    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Object__hasOwnProperty() throws ExpException {
        super("hasOwnProperty", 0);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            return new _Boolean(false);
        if (arguments[0] == null || arguments[0] == Expresser.UNDEFINED)
            return new _Boolean(false);

        ITypeConverter typeConverter = runtime.getTypeConverter();
        String propertyName = typeConverter.toString(runtime, arguments[0]).toString();
        Integer propertyId = StringToId.toId(propertyName);
        if (thisObject instanceof IExpObject) {
            IExpObject object = (IExpObject)thisObject;
            boolean result = object.isProperty(propertyId, false);
            return new _Boolean(result);
        } else {
            //  ̃\bh̓zXgIuWFNg this ƂĈƂ͂łȂi̐j
            return new _Boolean(false);
        }
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Object__hasOwnProperty();
        return instance;
    }
}
