package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Double;

/**
 * MathIuWFNg cos() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class _Math__cos extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("cos");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private _Math__cos() throws ExpException {
        super("cos", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            return new _Double(Double.NaN);
        double number;
        try {
            number = ((ExpNumberBase)(arguments[0])).doubleValue();
        } catch (ClassCastException cce) {
            number = runtime.getTypeConverter().toNumber(runtime, arguments[0]).doubleValue();
        }
        //  Java̎Op֐ PI / 2 𒴂ƌ덷݂iHjȂ̂ 0 ` PI / 2 ͈͓̔ɕϊČvZ
        number %= (2 * Math.PI);
        if (number < 0)
            number += (2 * Math.PI);
        if (number < Math.PI * 0.5)
            return new _Double(Math.cos(number));
        else if (number < Math.PI)
            return new _Double(Math.cos(Math.PI - number));
        else if (number < Math.PI * 1.5)
            return new _Double(Math.cos(number - Math.PI) * -1.0);
        else
            return new _Double(Math.cos(2 * Math.PI - number) * -1.0);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new _Math__cos();
        return instance;
    }

    /**
     * cos֐iOp֐jłB
     * @param number pxiWAj
     * @return vZ
     */
    public static double cos(double number) {
        //  Java̎Op֐ PI / 2 𒴂ƌ덷݂iHjȂ̂ 0 ` PI / 2 ͈͓̔ɕϊČvZ
        number %= (2 * Math.PI);
        if (number < 0)
            number += (2 * Math.PI);
        if (number < Math.PI * 0.5)
            return Math.cos(number);
        else if (number < Math.PI)
            return Math.cos(Math.PI - number);
        else if (number < Math.PI * 1.5)
            return Math.cos(number - Math.PI) * -1.0;
        else
            return Math.cos(2 * Math.PI - number) * -1.0;
    }
}
