package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._Double;

/**
 * MathIuWFNg min() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class _Math__min extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("min");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private _Math__min() throws ExpException {
        super("min", 2);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);
        
        double minnumber = Double.POSITIVE_INFINITY;
        int min = arguments.length;
        for (int idx = 0; idx < min; idx++) {
            if (arguments[idx] != null && arguments[idx] != Expresser.UNDEFINED) {
                double number;
                try {
                    number = ((ExpNumberBase)(arguments[0])).doubleValue();
                } catch (ClassCastException cce) {
                    number = runtime.getTypeConverter().toNumber(runtime, arguments[0]).doubleValue();
                }
                if (Double.isNaN(number))
                    return new _Double(Double.NaN);
                if (number < minnumber)
                    minnumber = number;
            }
        }
        return new _Double(minnumber);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new _Math__min();
        return instance;
    }
}
