package jp.gr.java_conf.matsubara.interpreter;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.interpreter.statement.IStatement;
import jp.gr.java_conf.matsubara.interpreter.statement.StatementResult;

/**
 * ͍ς݃XNvg\NXłB<br/>
 * 
 * 쐬: 2005/05/21
 * 
 * @author m.matsubara
 */

public class ParsedScript {
    /** ͍ς݂̃gbvxXe[ggiʏBlockStatementj */
    private IStatement topLevelStatement;
    /** \[X */
    private char[] source; 
    
    /** 
     * ͎Ɏgpꂽ RuntimeData<br/> 
     * s̃^Cf[^ defaultRuntime ƃO[oϐGALĂKv
     */
    private RuntimeData defaultRuntime;
    
    /**
     * ͍ς݃XNvg쐬
     * @param topLevelStatement sXe[gg(ʏBlockStatement)
     * @param defaultRuntime 
     */
    public ParsedScript(IStatement topLevelStatement, RuntimeData defaultRuntime) {
        this.topLevelStatement = topLevelStatement;
        this.defaultRuntime = defaultRuntime;
    }
    
    
    /**
     * XNvg̎ssB<br/>
     * VOXbhp
     * @return sʁi߂lj
     * @throws ExpException
     */
    public Object execute() throws ExpException {
        return execute(defaultRuntime);
    }
    
    /**
     * XNvg̎ssB<br/>
     * }`XbhΉ
     * @param runtime ^Cf[^
     * @return sʁi߂lj
     * @throws ExpException
     */
    public Object execute(RuntimeData runtime) throws ExpException {
        StatementResult result = topLevelStatement.execute(runtime);
        if (result != null) {
            switch (result.getStatementType()) {
            case StatementResult.ST_BREAK:
                throw new ExpException(ScriptEngine.getResString("NotProcessedBreak"), -1);
            case StatementResult.ST_CONTINUE:
                throw new ExpException(ScriptEngine.getResString("NotProcessedContinue"), -1);
            case StatementResult.ST_EXCEPTION:
                {
                    IExpObject error = (IExpObject)result.getResultValue();
                    String message = error.getProperty(StringToId.toId("message")).toString();
                    int position = ((ExpNumberBase)error.getProperty(StringToId.toId("position"))).intValue();
                    throw new ExpException(message, position);
                }
            case StatementResult.ST_RETURN:
            default:
                return result.getResultValue(); 
            }
        }
        return null;
    }
    
    /**
     * VXbhpӂăXNvg̎ssB
     * @throws ExpException
     */
    public void executeNewThread() {
        ScriptThread thread = new ScriptThread(this);
        thread.start();
    }
    
    /**
     * \[Xt@C̃eLXgԂ܂B
     * @return \[Xt@C̃eLXg
     */
    public char[] getSource() {
        return source;
    }
    
    /**
     * \[Xt@C̃eLXgݒ肵܂B
     * @param source \[Xt@C̃eLXg
     */
    public void setSource(char[] source) {
        this.source = source;
    }
    
    /**
     * ftHg̃^CIuWFNgԂ܂B
     * @return ftHg̃^CIuWFNg
     */
    public RuntimeData getDefaultRuntime() {
        return defaultRuntime;
    }
    
    /** 
     * ftHg̃^CIuWFNgݒ肵܂B
     * @param defaultRuntime ftHg̃^CIuWFNg
     */
    public void setDefaultRuntime(RuntimeData defaultRuntime) {
        this.defaultRuntime = defaultRuntime;
    }
}
