package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.HashMap;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;


/**
 * caseubNXe[ggłB
 * 
 * 쐬: 2005/02/26
 * 
 * @author m.matsubara
 */
public class CaseBlockStatement extends BlockStatement {
    private HashMap caseLabelMap = new HashMap();
    private int defaultCaseValuePosition = Integer.MAX_VALUE;
    private IParsedExpression caseExpression;
    
    
    /**
     * caseubN̐܂B
     * ie͏ɒǉȂ΂ȂȂj
     * 
     * @param caseExpression 
     */
    public CaseBlockStatement(IParsedExpression caseExpression) {
        this.caseExpression = caseExpression;
    }
    
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        Object caseValue = Expresser.evaluate(runtime, caseExpression);
        StatementResult receive = execute(runtime, caseValue);
        if (receive != null) {
            int statementType = receive.getStatementType();
            if (statementType == StatementResult.ST_BREAK)
                return null;
            return receive;
        }
        
        return null;
    }
    
    /**
     * w肳ꂽcaselɑΉʒus܂B
     * @param runtime ^Cf[^
     * @param caseValue casel
     * @throws ExpException
     * @throws SpecialStatement
     */
    public StatementResult execute(RuntimeData runtime, Object caseValue) throws ExpException {
        prepareBlockArray();
        
        int max = blockArray.length;
        for (int idx = getCaseLabelPos(caseValue); idx < max; idx++) {
            StatementResult receive = blockArray[idx].execute(runtime);
            if (receive != null) {
                if (receive.getStatementType() == StatementResult.ST_BREAK)
                    return null;
                return receive;
            }
        }
        return null;
    }
    
    /**
     * ŌɒǉꂽXe[gǧɃxǉ܂B
     * @param caseValue caselAdefault:o^Ƃnullw肷
     * @return ݒɐꍇ true łɓo^ς݂͎̎sAfalseԂ
     */
    public boolean addCaseLabel(Object caseValue) {
        if (caseValue != null) {
            if (caseLabelMap.get(caseValue) != null)
                return false;
            caseLabelMap.put(caseValue, new Integer(size()));
        }
        else {
            if (defaultCaseValuePosition != Integer.MAX_VALUE)
                return false;
            defaultCaseValuePosition = size();
        }
        return true;
    }
    
    /**
     * w肳ꂽID̃xʒu擾܂B
     * @param caseValue casel
     * @return xʒu
     */
    public int getCaseLabelPos(Object caseValue) {
        Integer pos = (Integer)caseLabelMap.get(caseValue);
        if (pos != null)
            return pos.intValue();
        else
            return defaultCaseValuePosition;
    }
}
