package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._String;


/**
 * for-in Xe[ggłB<br/>
 * 
 * 쐬: 2006/04/15
 * 
 * @author m.matsubara
 */
public class ForInStatement implements IStatement {
    /** ϐID */
    private Integer variableID;
    /** ΏۃIuWFNgID */
    /** ΏۃIuWFNg\ */
    private IParsedExpression objectExpression;
    /** xID */
    private Integer labelID;
    /** [v{ */
    private IStatement statement = null;
    
    
    
    /**
     * for-in Xe[gg̐܂B
     * @param variableID pϐID
     * @param objectExpression@ΏۃIuWFNgID 
     * @param statement [v{
     * @param labelID xꍇ
     */
    public ForInStatement(Integer variableID, IParsedExpression objectExpression, IStatement statement, Integer labelID) {
    	this.variableID = variableID;
        this.objectExpression = objectExpression;
        this.statement = statement;
        this.labelID = labelID;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        if (variableID.equals(id))
            result++;
        result += objectExpression.isUsingVariable(id);
        return result;
    }

    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData runtime)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        objectExpression.evaluate(runtime);
        IExpObject object = objectExpression.evaluate(runtime);
        if (object == null)
            return null;
        Integer[] properties = object.enumProperty();
        for (int idx = 0; idx < properties.length; idx++) {
            runtime.setValue(variableID, new _String(StringToId.toString(properties[idx])));
            if (statement != null) {
                StatementResult receive = statement.execute(runtime);
                if (receive != null) {
                    int statementType = receive.getStatementType();
                    if (statementType == StatementResult.ST_BREAK) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            return null;
                        else
                            return receive;
                    } else if (statementType == StatementResult.ST_CONTINUE) {
                        if (receive.getLabelId() == null || this.labelID == receive.getLabelId())   //  x̓CX^Ẍv
                            ;
                        else
                            return receive;
                    } else
                        return receive;
                }
            }
        }
        return null;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        if (statement != null)
            statement.registLocalVariable(varMap);
    }
}
