package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.Range;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;


/**
 * if Xe[ggłB<br/>
 * 
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 */
public class IfStatement implements IStatement {
    /** if ̏ */
    private Range conditionRange;
    private IParsedExpression condition;
    private IStatement thenStatement = null;
    private IStatement elseStatement = null;
    
    /**
     * if Xe[ggIuWFNg̍\z
     * @param condition 
     * @param conditionRange ͈
     * @param thenStatement  true ̎sXe[gg
     * @param elseStatement  else ̎sXe[gg
     * @throws ExpException
     * @throws ExpException
     */
    public IfStatement(IParsedExpression condition, Range conditionRange, IStatement thenStatement, IStatement elseStatement) {
        this.conditionRange = conditionRange;
        this.condition = condition;
        this.thenStatement = thenStatement;
        this.elseStatement = elseStatement;
    }
    
    /**
     * if ̏Ԃ
     * 
     * @return Xe[ggł͈̏̔
     */
    public Range getConditionRange() {
        return conditionRange;
    }
    
    /**
     * ]
     * @param runtime ^Cf[^
     * @return ]
     * @throws ExpException
     */
    public boolean condition(RuntimeData runtime) throws ExpException {
        IExpObject result = Expresser.evaluate(runtime, condition);
        if (result instanceof _Boolean) {
            return ((_Boolean)result).booleanValue();
        } else {
            return runtime.getTypeConverter().toBoolean(runtime, result).booleanValue();
        }
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        if (condition != null)
            result += condition.isUsingVariable(id);
        if (thenStatement != null)
            result += thenStatement.isUsingVariable(id);
        if (elseStatement != null)
            result += elseStatement.isUsingVariable(id);
        return result;
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        StatementResult receive = null;
        if (condition(runtime)) {
            if (thenStatement != null)
                receive = thenStatement.execute(runtime);
        } else {
            if (elseStatement != null)
                receive = elseStatement.execute(runtime);
        }
        return receive;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        if (thenStatement != null)
            thenStatement.registLocalVariable(varMap);
        if (elseStatement != null)
            elseStatement.registLocalVariable(varMap);
    }
}
