package jp.gr.java_conf.matsubara.interpreter.statement;

import java.util.Map;

import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.parsedexpression.IParsedExpression;


/**
 * synchronized Xe[ggłB<br/>
 * 
 * 쐬: 2005/05/17
 * 
 * @author m.matsubara
 *
 */
public class SynchronizedStatement implements IStatement {
    /** s߂̎łB */
    private IParsedExpression synchronizedExpression;
    /** ɎsXe[ggłB */
    private IStatement statement;
    
    
    public SynchronizedStatement(IParsedExpression synchronizedExpression, IStatement statement) {
        this.synchronizedExpression = synchronizedExpression;
        this.statement = statement;
    }


    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        int result = 0;
        if (synchronizedExpression != null)
            result += synchronizedExpression.isUsingVariable(id);
        if (statement != null)
            result += statement.isUsingVariable(id);
        return result;
    }

    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#execute(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public StatementResult execute(RuntimeData runtime) throws ExpException {
        if (statement != null) {
            Object object = synchronizedExpression.evaluate(runtime);
            if (object instanceof IVariable)
                object = ((IVariable)object).getValue();
            
            StatementResult result;
            synchronized (object) {
                result = statement.execute(runtime);
            }
            return result;
        }
        return null;
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.interpreter.statement.IStatement#registLocalVariable(java.util.Map)
     */
    public void registLocalVariable(Map varMap) {
        statement.registLocalVariable(varMap);
    }
}
