package jp.gr.java_conf.matsubara.regexp;

import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 * J2SDK1.4 œꂽK\T|[gIuWFNgłB<br/>
 * <br/>
 * 쐬: 2005/05/03
 * 
 * @author m.matsubara
 */
public class JavaRegExpCore implements IRegExpCore {
    Pattern pattern;
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.regexp.IRegExpCore#init(java.lang.String, java.lang.String)
     */
    public void init(String pattern, String flags) throws Exception {
        this.pattern = Pattern.compile(pattern);
    }

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.regexp.IRegExpCore#match(java.lang.String)
     */
    public RegMatchResult[] match(String source) {
        //  TODO Ӑ}lԂĂȂiƂj
        Matcher matcher = pattern.matcher(source);
        if (matcher.find()) {
            int max = matcher.groupCount() + 1;
            RegMatchResult[] result = new RegMatchResult[max];
            for (int idx = 0; idx < max; idx++) {
                int begin = matcher.start(idx);
                int end = matcher.end(idx);
                if (begin != -1 && end != -1)
                    result[idx] = new RegMatchResult(begin, end);
                else
                    result[idx] = null;
            }
            return result;
        }
        return null;
    }

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.regexp.IRegExpCore#test(java.lang.String)
     */
    public boolean test(String source) {
        Matcher matcher = pattern.matcher(source);
        return matcher.matches();
    }

    
    
}
